routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
Auth::routes();
Route::get('/', 'PostController@index');
Route::get('/home', 'HomeController@index')->name('home');

//user routes
Route::group(['middleware' => ['auth']], function () {
  Route::resource('posts', 'PostController');
  Route::get('my-posts', 'PostController@myPosts')->name('my-posts');
  Route::post('comment/create/{post}', 'PostCommentController@create')->name('comment.create');
});

//admin routes
Route::group(['middleware' => ['auth','admin']], function () {
    Route::get('admin-dashboard', 'AdminController@dashboard')->name('admin.dashboard');
    Route::get('admin/post/edit/{post}', 'AdminController@postEdit')->name('admin.post.edit');
    Route::post('admin/post/update/{post}', 'AdminController@postUpdate')->name('admin.post.update');
    Route::get('admin/report/user-list', 'AdminController@userList')->name('admin.userList');
    Route::get('admin/report/post-list', 'AdminController@postList')->name('admin.postList');
});

app/Post.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Post extends Model
{
    protected $guarded = [];  
    public function user()
    {
        return $this->belongsTo(User::class);
    }

    public function comments()
    {
        return $this->hasMany(PostComment::class);
    }
}

app/Http/Controllers/PostController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Post;
use Auth;

class PostController extends Controller
{

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        // Get all Posts, ordered by the newest first
        $posts = Post::latest()->get();

        // Pass Post Collection to view
        return view('posts.list', compact('posts'));
    }

    public function list()
    {
        // Get all Posts, ordered by the newest first
        $posts = Post::latest()->get();

        // Pass Post Collection to view
        return view('posts.list', compact('posts'));
    }

    public function myPosts()
    {
        // Get all Posts, ordered by the newest first
        $posts = Post::latest()->where('user_id',Auth::user()->id)->get();

        // Pass Post Collection to view
        return view('posts.myPosts', compact('posts'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
     public function create()
     {
         return view('posts.create');
     }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        // Validate posted form data
        $validated = $request->validate([
            'title' => 'required|string|unique:posts|min:5|max:100',
            'description' => 'required|string|min:5|max:2000',
        ]);

        // Create and save post with validated data
        $post = new Post;
        $post->title = $request->title;
        $post->description = $request->description;
        $post->user_id = Auth::user()->id;
        $post->save();

        // Redirect the user to the created post with a success notification
        return redirect(route('posts.show', [$post->id]))->with('notification', 'Post created!');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show(Post $post)
    {
        return view('posts.show', compact('post'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
     public function edit(Post $post)
     {
         return view('posts.edit', compact('post'));
     }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
     public function update(Request $request, Post $post)
     {
         // Validate posted form data
         $validated = $request->validate([
             'title' => 'required|string|min:5|max:100',
             'description' => 'required|string|min:5|max:2000',
         ]);

         //check the user is the ownwer of the post
         if ($post->user_id === Auth::user()->id) {
             // Update Post with validated data
             $post->update($validated);

             // Redirect the user to the created post woth an updated notification
             return redirect()->back()->with('notification', 'Post updated!');
        }

        return redirect()->back()->with('error_message', 'No access Permission!');

     }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

resources/views/posts/create.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-12">
            <div class="card">
                <div class="card-header"> <strong> {{ __('Create New Post') }} </strong>  </div>

                <div class="card-body">

                  @if ($errors->any())
                      <div class="alert alert-danger">
                          <ul>
                              @foreach ($errors->all() as $error)
                                  <li>{{ $error }}</li>
                              @endforeach
                          </ul>
                      </div>
                  @endif

                  <form method="post" action="{{ route('posts.store') }}">

                      @csrf

                      <div class="form-group">
                          <label class="label">Title</label>
                          <div class="control">
                              <input class="form-control"  type="text" name="title" value="{{ old('title') }}" class="input" placeholder="Title"  maxlength="100"  />
                          </div>
                      </div>

                      <div class="form-group">
                          <label class="label">Description</label>
                          <div class="control">
                              <textarea class="form-control" name="description" class="textarea" placeholder="Description" maxlength="2000"  rows="5">{{ old('description') }}</textarea>
                          </div>
                      </div>

                      <div class="form-group">
                          <div class="control">
                              <button type="submit" class="btn btn-info">Create</button>
                          </div>
                      </div>

                  </form>

                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/posts/edit.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-12">

          @if (session('notification'))
          <div class="alert alert-success">
             {{ session('notification') }}
          </div>
          @endif
          @if (session('error_message'))
          <div class="alert alert-danger">
             {{ session('error_message') }}
          </div>
          @endif
          
            <div class="card">
                <div class="card-header"> <strong> {{ __('Create New Post') }} </strong>  </div>

                <div class="card-body">

                  @if ($errors->any())
                      <div class="alert alert-danger">
                          <ul>
                              @foreach ($errors->all() as $error)
                                  <li>{{ $error }}</li>
                              @endforeach
                          </ul>
                      </div>
                  @endif



                  <form method="post" action="{{ route('posts.update', [$post->id]) }}">

                  @csrf
                  @method('patch')

                  <div class="form-group">
                      <label class="label">Title</label>
                      <div class="control">
                          <input class="form-control"  type="text" name="title" value="{{ $post->title }}" class="input" placeholder="Title"  maxlength="100"  />
                      </div>
                  </div>

                  <div class="form-group">
                      <label class="label">Description</label>
                      <div class="control">
                          <textarea class="form-control" name="description" class="textarea" placeholder="Description" maxlength="2000"  rows="5">{{ $post->description }}</textarea>
                      </div>
                  </div>


                  <div class="field">
                      <div class="control">
                          <button type="submit" class="btn btn-info">Update</button>
                      </div>
                  </div>

              </form>

                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/posts/list.blade.php
@extends('layouts.app')
@section('content')
<div class="container">
   <div class="row justify-content-center">
      <div class="col-md-12">
         @if (session('notification'))
         <div class="alert alert-success">
            {{ session('notification') }}
         </div>
         @endif
         @if (session('error_message'))
         <div class="alert alert-danger">
            {{ session('error_message') }}
         </div>
         @endif
         <div class="card">
            <div class="card-header">
              <strong> {{ __('All Post') }} </strong>
              <span style="float:right"> <a class="btn btn-sm btn-outline-primary" href="{{ route('posts.create') }}"> Add New</a>  </span> </div>
            <div class="card-body">

                @forelse ($posts as $post)
                <div class="content">
                   <a href="{{ route('posts.show', [$post->id]) }}">
                      <h1 class="title">{{ $post->title }}</h1>
                   </a>

                   <p style="color:gray;"> {{ $post->created_at->diffForHumans() }} by {{ $post->user->name}}</p>
                   @if(Auth::user() && Auth::user()->id == $post->user_id)
                   <form method="post" action="{{ route('posts.destroy', [$post->id]) }}">
                      @csrf @method('delete')
                      <div class="field is-grouped">
                         <div class="control">
                            <a class="btn btn-sm btn-outline-primary" href="{{ route('posts.edit', [$post->id])}}">Edit</a>
                         </div>
                         <!-- <div class="control">
                            <button type="submit" class="button is-danger is-outlined">
                              Delete
                            </button>
                            </div> -->
                      </div>
                   </form>

                   @endif
                   <hr>
                </div>
                @empty
                <p>No Posts</p>
                @endforelse


            </div>
         </div>
      </div>
   </div>
</div>
@endsection

resources/views/posts/myPosts.blade.php
@extends('layouts.app')
@section('content')
<div class="container">
   <div class="row justify-content-center">
      <div class="col-md-12">
         @if (session('notification'))
         <div class="alert alert-success">
            {{ session('notification') }}
         </div>
         @endif
         <div class="card">
            <div class="card-header">
              <strong> {{ __('My Posts') }} </strong>
              <span style="float:right"> <a class="btn btn-sm btn-outline-primary" href="{{ route('posts.create') }}"> Add New</a>  </span> </div>
            </div>
            <div class="card-body">

                @forelse ($posts as $post)
                <div class="content">
                   <a href="{{ route('posts.show', [$post->id]) }}">
                      <h1 class="title">{{ $post->title }}</h1>
                   </a>
                   <p>{!! nl2br(e($post->description)) !!}</p>
                   <p> {{ $post->created_at->diffForHumans() }} by {{ $post->user->name}}</p>
                   @if(Auth::user()->id == $post->user_id)
                   <form method="post" action="{{ route('posts.destroy', [$post->id]) }}">
                      @csrf @method('delete')
                      <div class="field is-grouped">
                         <div class="control">
                            <a class="btn btn-sm btn-outline-primary" href="{{ route('posts.edit', [$post->id])}}">Edit</a>
                         </div>
                         <!-- <div class="control">
                            <button type="submit" class="button is-danger is-outlined">
                              Delete
                            </button>
                            </div> -->
                      </div>
                   </form>
                   <hr>
                   @endif
                </div>
                @empty
                <p>No Posts</p>
                @endforelse


            </div>
         </div>
      </div>
   </div>
</div>
@endsection

resources/views/posts/show.blade.php
@extends('layouts.app')
@section('content')
<div class="container">
   <div class="row justify-content-center">
      <div class="col-md-12">
         @if (session('notification'))
         <div class="alert alert-success">
            {{ session('notification') }}
         </div>
         @endif

         @if ($errors->any())
             <div class="alert alert-danger">
                 <ul>
                     @foreach ($errors->all() as $error)
                         <li>{{ $error }}</li>
                     @endforeach
                 </ul>
             </div>
         @endif
         <div class="card">
            <div class="card-header"> <strong> {{ __('View Post') }} </strong>  </div>
            <div class="card-body">
               <div class="content">
                  <a href="{{ route('posts.show', [$post->id]) }}">
                     <h1 class="title">{{ $post->title }}</h1>
                  </a>
                  <p>{!! nl2br(e($post->description)) !!}</p>
                  <p style="color:gray;"> {{ $post->created_at->diffForHumans() }} by {{ $post->user->name}}</p>
                  @if(Auth::user()->id == $post->user_id)

                     <div class="field is-grouped">
                        <div class="control">
                           <a class="btn btn-sm btn-outline-primary" href="{{ route('posts.edit', [$post->id])}}">Edit</a>
                        </div>
                        <!-- <div class="control">
                           <button type="submit" class="button is-danger is-outlined">
                             Delete
                           </button>
                           </div> -->
                     </div>
                  @endif
               </div>
            </div>
         </div>
         <hr>
         <!-- comment section start -->
         <div class="card">
            <div class="card-header"> <strong> {{ __('Comments') }} </strong>  </div>
            <div class="card-body">
               <div class="content">

                  @if(Auth::user()->id == $post->user_id)
                     @forelse ($post->comments as $comment)
                     {{$comment->description}}<br>
                     <span style="color:gray;">{{ $comment->created_at->diffForHumans() }} by {{ $comment->user->name}}</span>
                     <hr>
                     @empty
                     <p>No Comments</p>
                     @endforelse

                  @endif
               </div>
            </div>
         </div>
         <!-- comment section end -->

         <!--Submit comment section start -->
         <div class="card">
            <div class="card-body">
               <div class="content">



                 <form method="post" action="{{ route('comment.create', [$post->id]) }}">

                     @csrf

                     <div class="form-group">
                         <label class="label">Comment</label>
                         <div class="control">
                             <textarea class="form-control" name="comment" class="textarea" placeholder="Commet" maxlength="2000"  rows="5">{{ old('comment') }}</textarea>
                         </div>
                     </div>

                     <div class="form-group">
                         <div class="control">
                             <button type="submit" class="btn btn-info">Submit</button>
                         </div>
                     </div>

                 </form>
               </div>
            </div>
         </div>
         <!--Submit comment section end -->

      </div>
   </div>
</div>
@endsection